Description

Record column is too narrow in the table documents (see the screenshot in attachment).

Associated revisions
Revision 41830 - 11/21/2014 05:38 AM - Joaquín  del Cerro Murciano

refs #2744. Record column is too narrow in the table documents

History
#1 - 10/28/2014 04:56 AM - Antonio Falciano

Priority: High

The record column width is fixed (i.e. not resizeable), so the record number becomes not visible starting from 10.

#2 - 10/28/2014 05:13 AM - Joaquín  del Cerro Murciano

Hola Antonio, 
en linux funciona correctamente. Ahora mismo no tengo un entorno de desarrollo en Windows y no he conseguido arreglarlo para Windows.
El codigo que lo crea la cabecera de las lineas esta en:

https://redmine.gvsig.net/redmine/projects/gvsig-desktop/repository/entry/trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.fmap.control/src/
ain/java/org/gvsig/fmap/mapcontrol/dal/feature/swing/FeatureTablePanel.java#L308

    private static class RowHeaderRenderer extends JButton implements ListCellRenderer {

        private JTable table = null;
        private final Dimension dimension = new Dimension();

        RowHeaderRenderer(JTable table) {
            JTableHeader header = table.getTableHeader();
            setOpaque(true);
            setBorder(UIManager.getBorder("TableHeader.cellBorder"));
            setHorizontalAlignment(CENTER);
            setForeground(header.getForeground());
            setBackground(header.getBackground());
            setFont(header.getFont());
            this.table = table;
            //                                               1234567
            Rectangle2D r = this.getFont().getStringBounds( "_______", new FontRenderContext(null,true,true));
            this.dimension.width = (int) r.getWidth();
        }

        public Component getListCellRendererComponent(JList list, Object value,
                int index, boolean isSelected, boolean cellHasFocus) {
            setText((value == null) ? "" : value.toString());
            this.dimension.height = this.table.getRowHeight(index);
            this.setPreferredSize(this.dimension);
            return this;
        }

    }

Intenta reservar espacio para al menos 7 digitos en la cabecera, de hecho en linux lo hace, y no entiendo por que en Windows no. Aparentemente
tiene espacio de sobra para mas de dos digitos.
Cuando tenga tiempo prepare un entorno de desarrollo para windows y vere que puede ser.

Ademas tampoco tengo claro ahora mismo como hacer que esa columna sea resizeable.

#3 - 10/28/2014 07:28 AM - Antonio Falciano
- Target version set to 2.1.0-2259-rc3
- File rowheader_workaround.png added
- File RowHeaderRenderer.patch added

Hi Joaquín,
thanks for your useful suggestions. As temporary workaround in order to increase the limit of viewable record index in Windows, it could be used the
preferred width of the table header (patch in attachment). But it allows to view only until the 99999th record index (screenshot). So the row header
should be resizeable to bypass this limit eventually.

#4 - 10/28/2014 08:04 AM - Álvaro Anguix
- Has patch set to Yes

#5 - 11/14/2014 05:47 AM - Joaquín  del Cerro Murciano
- Target version changed from 2.1.0-2259-rc3 to 2.1.0-2255-testing

#6 - 11/21/2014 12:07 PM - Antonio Falciano
- Status changed from New to Closed

Files
rec_column.png 41.7 KB 07/29/2014 Antonio Falciano
RowHeaderRenderer.patch 1.04 KB 10/28/2014 Antonio Falciano
rowheader_workaround.png 12.5 KB 10/28/2014 Antonio Falciano
